// class Cpu V1.0
// (c) Petter Schau 1996

#ifndef CPU
#define CPU

#include "my_types.h"

struct cputab {
	instructionexecutefunc execute_instruction;
    disassemblefunc disassemble_instruction;
	ULO source_register;
	ULO destination_register;
	addressmodereadfunc read_source;
	addressmodereadfunc read_destination;
	addressmodewritefunc write_destination;
	ULO cyclecount;
};


class Cpu {
	ULO d[8],a[8],sr,usp,ssp;
	struct cputab t[65536];
	UBY bcd2hex[256],hex2bcd[256];
};

