#define EVENTCOUNT    16384
#define EVENTMASK     0x3fff

#define IRQ1_0_TBE    0
#define IRQ1_1_DSKBLK 1
#define IRQ1_2_SOFT   2
#define IRQ2_CIAA     3
#define IRQ3_0_COPPER 4
#define IRQ3_1_VBL    5
#define IRQ3_2_BLIT   6
#define IRQ4_AUD      7
#define IRQ5_0_RBF    11
#define IRQ5_1_DSKSYN 12
#define IRQ6_0_CIAB   13
#define EXBUSERROR    25
#define EXODDADDRESS  26
#define EXILLEGAL     27
#define EXDIVBYZERO   28
#define EXPRIV        31
#define EXTRAP        32
#define EVSTOP        33


extern ULO logbuffer[EVENTCOUNT][16];
extern int logfirst;
extern int loglast;


// Logging flags
extern ULO logserialtransmitbufferemptyirq;
extern ULO logdiskdmatransferdoneirq;
extern ULO logsoftwareirq;
extern ULO logciaairq;
extern ULO logcopperirq;
extern ULO logverticalblankirq;
extern ULO logblitterreadyirq;
extern ULO logaudioirq;
extern ULO logserialreceivebufferfullirq;
extern ULO logdisksyncvaluerecognizedirq;
extern ULO logciabirq;
extern ULO logstop;
extern ULO logbuserrorex;
extern ULO logoddaddressex;
extern ULO logillegalinstructionex;
extern ULO logdivisionby0ex;
extern ULO logprivilegieviolationex;
extern ULO logtrapex;

