/*
// MEM routines, prototypes for use outside mem.cpp/mem.asm
*/

extern UBY *address_to_ptr(ULO address);
extern ULO config_memory_chipsize;
extern ULO config_memory_fastsize;
extern ULO config_memory_bogosize;
extern ULO config_memory_nokick;
extern ULO config_memory_kicksize;
extern UBY config_memory_kickname[];
extern ULO config_memory_romversion;
extern char kickstart_idstring[80];
extern char *rom_identify(char *s);

extern ULO vgareg2color[256];

extern ULO screenptr;

extern ULO fetb(ULO adress);
extern ULO fetw(ULO adress);
extern ULO fetl(ULO adress);

extern void wrib(ULO data,ULO adress);
extern void wriw(ULO data,ULO adress);
extern void wril(ULO data,ULO adress);
extern void dumpioblock(void);
extern ULO mem_init(void);
extern void hexdump(ULO);
extern void mem_initcolortranslation(void);
extern ULO dmaconr,dmacon;
extern ULO intenar,intena,intreq;
extern ULO potgor;


extern ULO lineflags[314];
/* Screen related registers */

extern ULO lof,xpos,ypos,diwxleft,diwxright,diwytop,diwybottom,ddfstrt,ddfstrtl,
    ddfstop,ddfstopl,topbottomflag,bpl1pt,bpl2pt,bpl3pt,bpl4pt,bpl5pt,bpl6pt,
    bplcon0,bplcon1,bplcon2,bpl1mod,bpl2mod,diwstrt,diwstop;

extern ULO DDFstartpos,DDFnumberofwords,DIWfirstvisiblepos,DIWlastvisiblepos;
extern ULO pagenr;

extern ULO adcon;

extern ULO shadcol[64];

extern ULO dskpt,dsklen,dsksync,pot0dat,pot1dat,joy0dat,joy1dat;

/* Copper registers */

extern ULO copcon,cop1lc,cop2lc,nxtcopaccess;

/* Blitter registers */

extern ULO bltcon,bltafwm,bltalwm,bltapt,bltbpt,bltcpt,bltdpt,bltamod,
    bltbmod,bltcmod,bltdmod,bltadat,bltbdat,bltcdat,blitteraccess,
    linenum,linecount,linelength,blitterdmawaiting,blitend,blitterstatus;

extern UBY cmem[];
extern UBY fmem[];
extern UBY bmem[];
extern UBY kmem[];

extern ULO decoderoutinetab[];
extern ULO decoderoutinedualtab[];


extern ULO decoderoutinetab[];
extern ULO decoderoutinedualtab[];

extern ULO sprpt[8],sprx[8],spry[8],sprly[8],spratt[8];
extern ULO spritestate[8];
extern ULO sprite16col[8];
extern UWO sprdat[8][2];

extern ULO oddscroll,evenscroll;
extern ULO oddhiscroll,evenhiscroll;

extern void dsetb(UBY data);
extern void dsetw(UWO data);
extern void dsetl(ULO data);
extern void dmem_setcounter(ULO val);
extern ULO dmem_getcounter(void);
extern void dmem_clear(void);

extern regreadfunc ioread[256];
extern regwritefunc iowrite[256];

